#include <bits/stdc++.h>
using namespace std;

#define rep(i, a, b) for (int i = a; i < (b); ++i)
#define all(x) begin(x), end(x)
#define sz(x) (int)(x).size()
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;

vi pr;
map<pii, pair<ll, int>> dp;

void f(vi &fr, ll i, ll j) {
    if (i + 1 == j) dp.insert({{i, j}, {0, 0}});
    if (dp.count({i, j})) return;
    ll mi = LONG_LONG_MAX;
    int split = 0;
    rep(k, i + 1, j) {
        f(fr, i, k);
        f(fr, k, j);
        int c = pr[j] + pr[k] - 2 * pr[i] + dp[{i, k}].first + dp[{k, j}].first;
        if (c < mi) mi = c, split = k;
    }
    dp[{i, j}] = {mi, split};
}

void print(ll i, ll j, string pref) {
    if (i + 1 == j) printf("%s\n", pref.c_str());
    else {
        ll split = dp[{i, j}].second;
        print(i, split, pref + "-");
        print(split, j, pref + ".");
    }
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    cin.exceptions(cin.failbit);
    ll n;
    cin >> n;
    string s;
    vi fr(n);
    pr.push_back(0);
    rep(i, 0, n) {
        getline(cin, s, '.');
        cin >> fr[i];
        pr.push_back(pr.back() + fr[i]);
    }
    f(fr, 0, n);
    print(0, n, "");
}